<?php
/*
 *********************************************************************************
 * class PgnGame
 *********************************************************************************
 */

/*
 * Create PgnGame
 */

class PgnGame	{

	/**
	 * Constructeur
	 */
	/*
	 *********************************************************************************
	 * class PgnGame
	 *********************************************************************************
	 */

	/*
	 * Create PgnGame
	 */
	function PgnGame() {
		$this->tags= array();
		$this->moves= array();
		$this->pgnMain= null;
		$this->name= "";
	}

	/*
	 * add piece
	 */
	function addMove(&$move) {
		$nb= count($this->moves);
		$this->moves[$nb]= &$move;
		$move->id= $nb;
	}

	/*
	 * add tag
	 */
	function addTag(&$tag) {
		$nb= count($this->tags);
		$this->tags[$nb]= &$tag;
	}

	/*
	 * search tag
	 */
	function searchTag($code) {
		$nb= count($this->tags);
		$code= strtolower($code);
		while ($nb > 0) {
			$nb--;
			$tag= &$this->tags[$nb];
			if ($tag->getCode()==$code) {
				return $tag->getValue();
			}
		}
		return null;
	}

	/*
	 * load pgn file
	 */
	function loadPgn(&$pgn) {
		global $pgnConst;
		$startTime= time();
		// creato pseudo-move
		$this->pgnStart= &new PgnMove($this);
		$this->pgnStart->setFenPosition($pgnConst->InitialFen);
		// get tags
		$this->loadTags($pgn);
		// and main game as variation
		$main= &new PgnVariation($this,0,$this->pgnStart);
		$this->pgnStart->addVariation($main);
		// load pgn into main game
		$main->load($pgn);

		$str= $this->searchTag('event');
		if ($str!=null) {
			$this->name= $str;
		}
		$stopTime= time();
		$duree= traceTime($startTime,$stopTime,"PgnGame.loadPgn");
	}

	/*
	 * load tag
	 */
	function loadTags(&$pgn) {
		while ( ($str=$pgn->nextToken()) != "" ) {

			switch(substr($str,0,1)) {
				case '[':	// tag
					$code= $pgn->nextToken();
					$value= $pgn->nextToken();
					$this->addTag(new PgnTag($code,$value));
					$pgn->nextToken();
					if ($code=="FEN") {
						$this->pgnStart->setFenPosition($value);
					}
					break;

				default:	// no more tage : game begins here
					$pgn->unread();
					return;
					break;

			}
		}

	}

	/*
	 * write game
	 */
	function write() {
		writeToken("GAME");
		writeEol();
		$i= 0;
		while ($i < count($this->tags)) {
			$tag= &$this->tags[$i];
			$tag->write();
			$i++;
		}

		/*
		$i= 0;
		$nbr= count($this->moves);
		while ($i < $nbr) {
			$move= &$this->moves[$i];
			$move->write();
			$i++;
		}
		*/

		$this->pgnStart->write();
		writeToken("END");
		writeEol();
	}

	/*
	 * dump game
	 */
	function dump() {
		trace("Liste des TAGS :");
		$i= 0;
		while ($i < count($this->tags)) {
			$tag= &$this->tags[$i];
			trace(" - - " . $tag->code . "=" . $tag->value);
			$i++;
		}

		$i= 0;
		while ($i < count($this->moves)) {
			$move= &$this->moves[$i];
			trace(" - - ".$i." " . $move->id . "=" . $move->code);
			$i++;
		}

		$this->pgnStart->dump(0);
	}

}

?>
