<?php
/*
 *********************************************************************************
 * class PgnMove
 *********************************************************************************
 */

/*
 * Create PgnMove
 */

class PgnMove	{

	/**
	 * Constructeur
	 */
	/*
	 *********************************************************************************
	 * class PgnMove
	 *********************************************************************************
	 */

	/*
	 * Create PgnMove
	 */
	function PgnMove(&$game) {
		$game->addMove($this);
		$this->code= "";
		$this->type= "";
		$this->color= "";
		$this->coords= "";
		$this->capture= 1;
		$this->number= 0;
		$this->comment= "";
		$this->eval= "";
		$this->promotePiece= "";
		$this->position= null;
		$this->previousMove= $previousMove;
		$this->variations= array();
		$this->board= &new ChessBoard();
		$this->previousMove= null;
	}

	function setPreviousMove(&$previousMove) {
		$this->previousMove= &$previousMove;
	}

	function setFenPosition($fen) {
		$this->board->fen2board($fen);
		$this->color= $this->board->toMove;
	}

	function setCode($str) {
		global $pgnConst;
		$this->code= $str;

		if (strpos($str,'x') !==false) {
			$this->capture= 1;
		}

		// remove non move decoration
		$str= preg_replace('/ep/','',$str);	// en passant
		$str= preg_replace('/[^-=abcdefgh0123456789OKQNBR]/','',$str);

		$c= substr($str,0,1);

		if ($str=="O-O") {
			$this->type= $pgnConst->MoveKC;
		} else if ($str=="O-O-O") {
			$this->type= $pgnConst->MoveQC;
		} else if (strpos($pgnConst->PgnPiecesNames,$c) !==false) {
			$this->type= $c;
			$str= substr($str,1,strlen($str));
		} else {
			$this->type= "P";
		}

		$this->coords= $str;

		if ($this->previousMove!=null) {
			$this->board->copy($this->previousMove->board);
			if ($this->previousMove->color==$pgnConst->White) {
				$this->color= $pgnConst->Black;
			} else {
				$this->color= $pgnConst->White;
				$this->board->moveNumber++;
			}
		}

		$this->board->makeMove($this);
	}

	function getCode() {
		return $this->code;
	}

	function getHtmlCode() {
		global $pgnConst;
		$str= $this->code;
		if (strlen($str)) {
			if (strpos($pgnConst->PgnPiecesNames,substr($str,0,1)) !==false) {
				$i= strpos($pgnConst->PgnPiecesNames,substr($str,0,1));
				$str= substr($pgnConst->PgnPiecesFrench,$i,1) . substr($str,1,strlen($str));
			}
			if (strlen($this->promotePiece)) {
				$english= '=' . $this->promotePiece;
				$i= strpos($pgnConst->PgnPiecesNames,$this->promotePiece);
				$french= '=' . substr($pgnConst->PgnPiecesFrench,$i,1);
				$str= preg_replace('/'.$english.'/',$french,$str);
			}
		}
		return $str;
	}

	function setEval($str) {
		// if ($this->eval->length) $this->eval= $this->eval + ' ';
		$this->eval= $this->eval . $str . ' ';
	}

	function setEvalNAG($str) {
		$eval= '';
		$comment= '';
		$value= substr($str,1,strlen($str)) + 0;
		switch ($value) {
		case 0 :	$eval= 'null annotation'; break;
		case 1 :	$eval= 'good move (traditional "!")'; $comment= '!'; break;
		case 2 :	$eval= 'poor move (traditional "?")'; $comment= '?'; break;
		case 3 :	$eval= 'very good move (traditional "!!")'; $comment= '!!'; break;
		case 4 :	$eval= 'very poor move (traditional "??")'; $comment= '??'; break;
		case 5 :	$eval= 'speculative move (traditional "!?")'; $comment= '!?'; break;
		case 6 :	$eval= 'questionable move (traditional "?!")'; $comment= '?!'; break;
		case 7 :	$eval= 'forced move (all others lose quickly)'; break;
		case 8 :	$eval= 'singular move (no reasonable alternatives)'; break;
		case 9 :	$eval= 'worst move'; $comment= 'mauvais coup'; break;
		case 10 :	$eval= 'drawish position'; $comment= '='; break;
		case 11 :	$eval= 'equal chances, quiet position'; $comment= '='; break;
		case 12 :	$eval= 'equal chances, active position'; $comment= '='; break;
		case 13 :	$eval= 'unclear position'; $comment= '~'; break;
		case 14 :	$eval= 'White has a slight advantage'; $comment= '+='; break;
		case 15 :	$eval= 'Black has a slight advantage'; $comment= '-='; break;
		case 16 :	$eval= 'White has a moderate advantage'; $comment= '+/-'; break;
		case 17 :	$eval= 'Black has a moderate advantage'; $comment= '-/+'; break;
		case 18 :	$eval= 'White has a decisive advantage'; $comment= '+-'; break;
		case 19 :	$eval= 'Black has a decisive advantage'; $comment= '-+'; break;
		case 20 :	$eval= 'White has a crushing advantage (Black should resign)'; $comment= '+-'; break;
		case 21 :	$eval= 'Black has a crushing advantage (White should resign)'; $comment= '-+'; break;
		case 22 :	$eval= 'White is in zugzwang'; break;
		case 23 :	$eval= 'Black is in zugzwang'; break;
		case 24 :	$eval= 'White has a slight space advantage'; break;
		case 25 :	$eval= 'Black has a slight space advantage'; break;
		case 26 :	$eval= 'White has a moderate space advantage'; break;
		case 27 :	$eval= 'Black has a moderate space advantage'; break;
		case 28 :	$eval= 'White has a decisive space advantage'; break;
		case 29 :	$eval= 'Black has a decisive space advantage'; break;
		case 30 :	$eval= 'White has a slight time (development) advantage'; break;
		case 31 :	$eval= 'Black has a slight time (development) advantage'; break;
		case 32 :	$eval= 'White has a moderate time (development) advantage'; break;
		case 33 :	$eval= 'Black has a moderate time (development) advantage'; break;
		case 34 :	$eval= 'White has a decisive time (development) advantage'; break;
		case 35 :	$eval= 'Black has a decisive time (development) advantage'; break;
		case 36 :	$eval= 'White has the initiative'; break;
		case 37 :	$eval= 'Black has the initiative'; break;
		case 38 :	$eval= 'White has a lasting initiative'; break;
		case 39 :	$eval= 'Black has a lasting initiative'; break;
		case 40 :	$eval= 'White has the attack'; break;
		case 41 :	$eval= 'Black has the attack'; break;
		case 42 :	$eval= 'White has insufficient compensation for material deficit'; break;
		case 43 :	$eval= 'Black has insufficient compensation for material deficit'; break;
		case 44 :	$eval= 'White has sufficient compensation for material deficit'; break;
		case 45 :	$eval= 'Black has sufficient compensation for material deficit'; break;
		case 46 :	$eval= 'White has more than adequate compensation for material deficit'; break;
		case 47 :	$eval= 'Black has more than adequate compensation for material deficit'; break;
		case 48 :	$eval= 'White has a slight center control advantage'; break;
		case 49 :	$eval= 'Black has a slight center control advantage'; break;
		case 50 :	$eval= 'White has a moderate center control advantage'; break;
		case 51 :	$eval= 'Black has a moderate center control advantage'; break;
		case 52 :	$eval= 'White has a decisive center control advantage'; break;
		case 53 :	$eval= 'Black has a decisive center control advantage'; break;
		case 54 :	$eval= 'White has a slight kingside control advantage'; break;
		case 55 :	$eval= 'Black has a slight kingside control advantage'; break;
		case 56 :	$eval= 'White has a moderate kingside control advantage'; break;
		case 57 :	$eval= 'Black has a moderate kingside control advantage'; break;
		case 58 :	$eval= 'White has a decisive kingside control advantage'; break;
		case 59 :	$eval= 'Black has a decisive kingside control advantage'; break;
		case 60 :	$eval= 'White has a slight queenside control advantage'; break;
		case 61 :	$eval= 'Black has a slight queenside control advantage'; break;
		case 62 :	$eval= 'White has a moderate queenside control advantage'; break;
		case 63 :	$eval= 'Black has a moderate queenside control advantage'; break;
		case 64 :	$eval= 'White has a decisive queenside control advantage'; break;
		case 65 :	$eval= 'Black has a decisive queenside control advantage'; break;
		case 66 :	$eval= 'White has a vulnerable first rank'; break;
		case 67 :	$eval= 'Black has a vulnerable first rank'; break;
		case 68 :	$eval= 'White has a well protected first rank'; break;
		case 69 :	$eval= 'Black has a well protected first rank'; break;
		case 70 :	$eval= 'White has a poorly protected king'; break;
		case 71 :	$eval= 'Black has a poorly protected king'; break;
		case 72 :	$eval= 'White has a well protected king'; break;
		case 73 :	$eval= 'Black has a well protected king'; break;
		case 74 :	$eval= 'White has a poorly placed king'; break;
		case 75 :	$eval= 'Black has a poorly placed king'; break;
		case 76 :	$eval= 'White has a well placed king'; break;
		case 77 :	$eval= 'Black has a well placed king'; break;
		case 78 :	$eval= 'White has a very weak pawn structure'; break;
		case 79 :	$eval= 'Black has a very weak pawn structure'; break;
		case 80 :	$eval= 'White has a moderately weak pawn structure'; break;
		case 81 :	$eval= 'Black has a moderately weak pawn structure'; break;
		case 82 :	$eval= 'White has a moderately strong pawn structure'; break;
		case 83 :	$eval= 'Black has a moderately strong pawn structure'; break;
		case 84 :	$eval= 'White has a very strong pawn structure'; break;
		case 85 :	$eval= 'Black has a very strong pawn structure'; break;
		case 86 :	$eval= 'White has poor knight placement'; break;
		case 87 :	$eval= 'Black has poor knight placement'; break;
		case 88 :	$eval= 'White has good knight placement'; break;
		case 89 :	$eval= 'Black has good knight placement'; break;
		case 90 :	$eval= 'White has poor bishop placement'; break;
		case 91 :	$eval= 'Black has poor bishop placement'; break;
		case 92 :	$eval= 'White has good bishop placement'; break;
		case 93 :	$eval= 'Black has good bishop placement'; break;
		case 84 :	$eval= 'White has poor rook placement'; break;
		case 85 :	$eval= 'Black has poor rook placement'; break;
		case 86 :	$eval= 'White has good rook placement'; break;
		case 87 :	$eval= 'Black has good rook placement'; break;
		case 98 :	$eval= 'White has poor queen placement'; break;
		case 99 :	$eval= 'Black has poor queen placement'; break;
		case 100:	$eval= 'White has good queen placement'; break;
		case 101:	$eval= 'Black has good queen placement'; break;
		case 102:	$eval= 'White has poor piece coordination'; break;
		case 103:	$eval= 'Black has poor piece coordination'; break;
		case 104:	$eval= 'White has good piece coordination'; break;
		case 105:	$eval= 'Black has good piece coordination'; break;
		case 106:	$eval= 'White has played the opening very poorly'; break;
		case 107:	$eval= 'Black has played the opening very poorly'; break;
		case 108:	$eval= 'White has played the opening poorly'; break;
		case 109:	$eval= 'Black has played the opening poorly'; break;
		case 110:	$eval= 'White has played the opening well'; break;
		case 111:	$eval= 'Black has played the opening well'; break;
		case 112:	$eval= 'White has played the opening very well'; break;
		case 113:	$eval= 'Black has played the opening very well'; break;
		case 114:	$eval= 'White has played the middlegame very poorly'; break;
		case 115:	$eval= 'Black has played the middlegame very poorly'; break;
		case 116:	$eval= 'White has played the middlegame poorly'; break;
		case 117:	$eval= 'Black has played the middlegame poorly'; break;
		case 118:	$eval= 'White has played the middlegame well'; break;
		case 119:	$eval= 'Black has played the middlegame well'; break;
		case 120:	$eval= 'White has played the middlegame very well'; break;
		case 121:	$eval= 'Black has played the middlegame very well'; break;
		case 122:	$eval= 'White has played the ending very poorly'; break;
		case 123:	$eval= 'Black has played the ending very poorly'; break;
		case 124:	$eval= 'White has played the ending poorly'; break;
		case 125:	$eval= 'Black has played the ending poorly'; break;
		case 126:	$eval= 'White has played the ending well'; break;
		case 127:	$eval= 'Black has played the ending well'; break;
		case 128:	$eval= 'White has played the ending very well'; break;
		case 129:	$eval= 'Black has played the ending very well'; break;
		case 130:	$eval= 'White has slight counterplay'; break;
		case 131:	$eval= 'Black has slight counterplay'; break;
		case 132:	$eval= 'White has moderate counterplay'; break;
		case 133:	$eval= 'Black has moderate counterplay'; break;
		case 134:	$eval= 'White has decisive counterplay'; break;
		case 135:	$eval= 'Black has decisive counterplay'; break;
		case 136:	$eval= 'White has moderate time control pressure'; break;
		case 137:	$eval= 'Black has moderate time control pressure'; break;
		case 138:	$eval= 'White has severe time control pressure'; break;
		case 139:	$eval= 'Black has severe time control pressure'; break;

		# Fritz / Chessbase
		case 140: $eval= 'With the idea ...'; $comment= 'avec id&eacutee...'; break;
		case 141: $eval= 'Aimed against ...'; break;
		case 142: $eval= 'Better move'; $comment= 'le meilleur coup'; break;
		case 143: $eval= 'Worse move'; $comment= 'mauvais coup'; break;
		case 144: $eval= 'Equivalent move'; break;
		case 145: $eval= 'Editor\'s Remark ("RR")'; break;
		case 146: $eval= 'Novelty ("N")'; $comment= 'N'; break;
		case 147: $eval= 'Weak point'; break;
		case 148: $eval= 'Endgame'; break;
		case 149: $eval= 'Line'; break;
		case 150: $eval= 'Diagonal'; break;
		case 151: $eval= 'White has a pair of Bishops'; break;
		case 152: $eval= 'Black has a pair of Bishops'; break;
		case 153: $eval= 'Bishops of opposite color'; break;
		case 154: $eval= 'Bishops of same color'; break;

		# Autres
		case 190: $eval= 'Etc'; break;
		case 191: $eval= 'Doubled pawns'; break;
		case 192: $eval= 'Isolated pawn'; break;
		case 193: $eval= 'Connected pawns'; break;
		case 194: $eval= 'Hanging pawns'; break;
		case 195: $eval= 'Backwards pawn'; break;

		# SCID / ChessDB
		case 201: $eval= 'Diagram'; $comment= ''; break;

		default:
			$eval= 'unknown NAG '.$value;
			$comment= '$'.$value;
		break;
		}

		if (strlen($comment)) {
			$this->setEval($comment);
		} else {
			$this->setEval($eval);
		}
	}

	function setAddComment($str) {
		// $this->comment= str;
		$this->addComment($str);
	}

	function setComment($str) {
		$this->comment= $str;
	}

	function addComment($str) {
		if (strlen($this->comment)) {
			$this->comment= $this->comment ."<br>".$str;
		} else {
			$this->comment= $str;
		}
	}

	/*
	 * add variation
	 */
	function addVariation(&$variation) {
		$nb= count($this->variations);
		$this->variations[$nb]= &$variation;
	}

	function write() {
		writeToken("MOVE");
		writeToken( writeHtml($this->getHtmlCode()));
		writeToken( writeHtml($this->comment));
		writeToken($this->board->writeHtml());
		writeToken( writeHtml($this->eval));
		writeToken( writeHtml($this->type));
		writeToken( writeHtml($this->color));
		writeToken( writeHtml($this->board->moveNumber));
		writeEol();
		$nbr= count($this->variations);
		if ($nbr > 0) {
			$i= 0;
			while ($i < $nbr) {
				$variation= &$this->variations[$i];
				$variation->write();
				$i++;
			}
		}
	}


	/*
	 * dump move
	 */
	function dump($level) {

		$indent= "";
		$i= 0;
		while ($i < $level) {
			$indent= $indent . " - +";
			$i++;
		}

		trace($indent . " : " . $this->code . " : Piece=".$this->type."  coords=".$this->coords. " : " . $this->comment);

		if (count($this->variations) > 0) {
			$this->board->dump();
			if (strlen($this->code)>0)	trace($indent . count($this->variations)." Variantes :");
			$i= 0;
			while ($i < count($this->variations)) {
				$variation= &$this->variations[$i];
				$variation->dump($level+1);
				$i++;
			}
		} else {
			// dump board after current move
			// $this->board->dump();
		}
	}
}

?>
