<?php
/*
 *********************************************************************************
 * class PgnVariation
 *********************************************************************************
 */

/*
 * Create PgnVariation
 */

class PgnVariation	{

	/**
	 * Constructeur
	 */
	/*
	 *********************************************************************************
	 * class PgnVariation
	 *********************************************************************************
	 */

	/*
	 * Create PgnVariation
	 */
	function PgnVariation(&$game,$variation,&$move) {
		$this->parentMove= $move;
		$this->game= $game;
		$this->moves= array();
		$this->comment= '';
		$this->postComment= '';
		$this->variation= $variation;
	}

	function setComment($str) {
		$this->comment= $str;
	}

	function getComment() {
		return $this->comment;
	}

	function setPostComment($str) {
		$this->postComment= $str;
	}

	function getPostComment() {
		return $this->postComment;
	}

	/*
	 * add move
	 */
	function addMove(&$move) {
	$nb= count($this->moves);
		$move->variation= &$this;
		$move->var_move_id= $nb;
		$this->moves[$nb]= &$move;
	}

	/*
	 * load pgn
	 */
	function load(&$pgn) {
		$lastMove= $this->parentMove;
		$move= $this->parentMove;

		while ( ($str=$pgn->nextToken()) != "" ) {
			switch($pgn->lastSep) {
				case '{':	// comment
					if ($move==null) {
						$this->setComment($str);
					} else {
						$move->setComment($str);
					}
					break;

				default:
					switch(substr($str,0,1)) {
						case '[':	// tag : other game
							$pgn->unread();
							return;
							break;

						case '(':	// variation
							$variation= &new PgnVariation($this->game,1,$move->previousMove);
							$variation->load($pgn);
							$move->addVariation($variation);
							break;

						case ')':	// end variation
							return;
							break;

						case '$':	// coded comment
							$move->setEvalNAG($str);
							break;

						case '?':	// comment
						case '!':	// comment
						case '+':	// comment
						case '-':	// comment
						case '=':	// comment
							$move->setEval($str);
							break;

						default:	// move
							switch($str) {
								case '1-0':
								case '0-1':
								case '1/2':
								case '1/2-1/2':
								case '*':
									// game result
									// todo : save this for display
									$this->setPostComment($str);
									break;
								default:
									// remove move number
									$str = preg_replace('/[0-9][0-9]*\.\.\./'," ",$str);
									$str = preg_replace('/[0-9][0-9]*\./'," ",$str);
									$str = preg_replace('/\.\.\./'," ",$str);
									$str = preg_replace('/^ */',"",$str);
									$str = preg_replace('/ *$/',"",$str);
									if (strlen($str)) {
										$lastMove= $move;
										$move= &new PgnMove($this->game);
										$move->setPreviousMove($lastMove);
										$move->setCode($str);
										$this->addMove($move);
									}
									break;
							}
							break;

					}
					break;
			}
		}

	}

	/*
	 * write game
	 */
	function write() {
		writeToken( "VARIATION");
		writeToken( writeHtml($this->comment));
		writeToken( writeHtml($this->postComment));
		writeEol();

		$i= 0;
		$nbr= count($this->moves);
		while ($i < $nbr) {
			$move= &$this->moves[$i];
			$move->write();
			$i++;
		}

		writeToken( "END");
		writeEol();
	}

	/*
	 * dump game
	 */
	function dump($level) {
		$indent= "";
		$i= 0;
		while ($i < $level) {
			$indent= $indent . " - +";
			$i++;
		}

		if (strlen($this->comment)>0)	trace($indent . $this->comment);
		trace($indent . "Moves :");
		$i= 0;
		while ($i < count($this->moves)) {
			$move= &$this->moves[$i];
			$move->dump($level);
			$i++;
		}

		trace("Final board :");
		$move->board->dump();
	}
}

?>
