<?php
/*
 * read a PGN file
 * send content thru htmlentities for characters conversions
 */

require_once 'PgnConst.class.php';
global $pgnConst;
$pgnConst= &new PgnConst();

require_once 'StringTokenizer.class.php';

require_once 'ChessBoard.class.php';
require_once 'ChessPiece.class.php';
require_once 'PgnGame.class.php';
require_once 'PgnMove.class.php';
require_once 'PgnTag.class.php';
require_once 'PgnVariation.class.php';


/*
 *********************************************************************************
 * Traces
 *********************************************************************************
 */

global	$traceOk;
$traceOk= 0;

function traceString($mesg) {
	global $traceOk;
	if ($traceOk==0)	return;
	echo "$mesg";
}

function traceNL() {
	global $traceOk;
	if ($traceOk==0)	return;
	echo "\n";
}

function trace($mesg) {
	traceString($mesg);
	traceNL();
}

function traceTime($start,$end,$mesg) {
	$duree= $end - $start;
	traceString("($duree) : ".$mesg);
	traceNL();
	return $duree;
}

function traceError($mesg) {
	echo "ERROR : $mesg\n";
}

/*
 *********************************************************************************
 * write
 *********************************************************************************
 */

function writeHtml($mesg) {
	return $mesg;
	// return htmlentities($mesg);
}

function writeToken($mesg) {
	echo "$mesg";
	echo "\t";
}

function writeEol() {
	echo "\n";
}

/*
 *********************************************************************************
 * Programme principal
 *********************************************************************************
 */

if ($argc > 1) {
	$filename= $argv[1];
} else {
	$vars= array();
	if ($_POST) {
		$vars= &$_POST;
	} else {
		if ($_GET) {
			$vars= &$_GET;
		}
	}
	$filename= $vars['pgnfile'];
}

$startTime= time();
$str= file_get_contents($filename);

$st= &new StringTokenizer($str);

$games= array();
$nb= 0;
while ( $st->hasMoreGame() ) {
	$game= &new PgnGame();
	$game->loadPgn($st);
	$games[$nb]= &$game;
	$nb++;
}
$stopTime= time();
$dureeLoad= traceTime($startTime,$stopTime,"Main");

$startTime= time();
writeToken("PGN");
writeToken("OK");
writeToken("loadTime : " . $dureeLoad);
writeEol();
$i= 0;
while ( $i < $nb ) {
	$game= &$games[$i];
	$game->write();
	$i++;
}
$stopTime= time();
$dureeWrite= traceTime($startTime,$stopTime,"Main");
writeToken("END");
writeToken("loadTime : " . $dureeLoad . " " . "sendTime : " . $dureeWrite);
writeEol();

 /*
echo htmlentities($str);
 */

?>
